﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Numerics;
using System.Text;
using System.Threading.Tasks;

namespace AVSchool.Models
{
    public partial class Teacher
    {
        public string newGender
        {
            get
            {
                if (IdGenderNavigation.Gender1 == "ж")
                {
                    return "женский";
                }
                else
                {
                    return "мужской";
                }
            }
        }
        public string newBirthdate
        {
            get
            {
                DateTime bd = DateBirth.Value;
                return bd.ToString("dd.MM.yyyy");
            }
        }
        public string newExpirience
        {
            get
            {
                int y = (int)(Experience / 12);
                int m = (int)(Experience % 12);
                return $"{y} год {m} мес";
            }
        }
        public string newHourse
        {
            get
            {
                int count = 0;
                foreach (var item in CourseTeachers)
                {
                    count += Convert.ToInt32(item.Time);
                }
                if (count == 0)
                {
                    return $"Курсов нет";
                }
                else
                {
                    return $"{count} ч.";
                }
            }
        }

        public List<string> newCourses
        {
            get
            {
                List<string> list = new List<string>();
                foreach (var item in CourseTeachers)
                {
                    list.Add(item.IdCourseNavigation.NameCourse);
                }
                if (!list.Any())
                {
                    list.Add("Курсов нет");
                }
                return list;
            }
        }

        public List<string> newSubjects
        {
            get
            {
                List<string> list = new List<string>();
                foreach (var item in DisciplinesTaughts)
                {
                    list.Add("- " + item.IdItemNavigation.Item1);
                }
                return list;
            }
        }
    }
}

