﻿using System;
using System.Collections.Generic;
using Microsoft.EntityFrameworkCore;

namespace AVSchool.Models;

public partial class _43pAstashinContext : DbContext
{
    public _43pAstashinContext()
    {
    }

    public _43pAstashinContext(DbContextOptions<_43pAstashinContext> options)
        : base(options)
    {
    }

    public virtual DbSet<Course> Courses { get; set; }

    public virtual DbSet<CourseTeacher> CourseTeachers { get; set; }

    public virtual DbSet<DisciplinesTaught> DisciplinesTaughts { get; set; }

    public virtual DbSet<Gender> Genders { get; set; }

    public virtual DbSet<Item> Items { get; set; }

    public virtual DbSet<Teacher> Teachers { get; set; }

    protected override void OnConfiguring(DbContextOptionsBuilder optionsBuilder)
#warning To protect potentially sensitive information in your connection string, you should move it out of source code. You can avoid scaffolding the connection string by using the Name= syntax to read it from configuration - see https://go.microsoft.com/fwlink/?linkid=2131148. For more guidance on storing connection strings, see http://go.microsoft.com/fwlink/?LinkId=723263.
        => optionsBuilder.UseNpgsql("Host=edu.pg.ngknn.local;Port=5432;Database=43P_Astashin;Username=43P;Password=444444");

    protected override void OnModelCreating(ModelBuilder modelBuilder)
    {
        modelBuilder.Entity<Course>(entity =>
        {
            entity.HasKey(e => e.IdCourse).HasName("course_pk");

            entity.ToTable("course");

            entity.Property(e => e.IdCourse)
                .UseIdentityAlwaysColumn()
                .HasColumnName("id_course");
            entity.Property(e => e.NameCourse)
                .HasColumnType("character varying")
                .HasColumnName("name_course");
        });

        modelBuilder.Entity<CourseTeacher>(entity =>
        {
            entity.HasKey(e => e.IdCourseTeachers).HasName("course_teachers_pk");

            entity.ToTable("course_teachers");

            entity.Property(e => e.IdCourseTeachers)
                .UseIdentityAlwaysColumn()
                .HasColumnName("id_course_teachers");
            entity.Property(e => e.IdCourse).HasColumnName("id_course");
            entity.Property(e => e.IdTeacher).HasColumnName("id_teacher");
            entity.Property(e => e.Time).HasColumnName("time");

            entity.HasOne(d => d.IdCourseNavigation).WithMany(p => p.CourseTeachers)
                .HasForeignKey(d => d.IdCourse)
                .OnDelete(DeleteBehavior.ClientSetNull)
                .HasConstraintName("course_teachers_fk");

            entity.HasOne(d => d.IdTeacherNavigation).WithMany(p => p.CourseTeachers)
                .HasForeignKey(d => d.IdTeacher)
                .OnDelete(DeleteBehavior.ClientSetNull)
                .HasConstraintName("course_teachers_fk_1");
        });

        modelBuilder.Entity<DisciplinesTaught>(entity =>
        {
            entity.HasKey(e => e.Id).HasName("disciplines_taught_pk");

            entity.ToTable("disciplines_taught");

            entity.Property(e => e.Id)
                .UseIdentityAlwaysColumn()
                .HasColumnName("id");
            entity.Property(e => e.IdItem).HasColumnName("id_item");
            entity.Property(e => e.IdTeacher).HasColumnName("id_teacher");

            entity.HasOne(d => d.IdItemNavigation).WithMany(p => p.DisciplinesTaughts)
                .HasForeignKey(d => d.IdItem)
                .OnDelete(DeleteBehavior.ClientSetNull)
                .HasConstraintName("disciplines_taught_fk");

            entity.HasOne(d => d.IdTeacherNavigation).WithMany(p => p.DisciplinesTaughts)
                .HasForeignKey(d => d.IdTeacher)
                .OnDelete(DeleteBehavior.ClientSetNull)
                .HasConstraintName("disciplines_taught_fk_1");
        });

        modelBuilder.Entity<Gender>(entity =>
        {
            entity.HasKey(e => e.IdGender).HasName("gender_pk");

            entity.ToTable("gender");

            entity.Property(e => e.IdGender)
                .UseIdentityAlwaysColumn()
                .HasColumnName("id_gender");
            entity.Property(e => e.Gender1)
                .HasColumnType("character varying")
                .HasColumnName("gender");
        });

        modelBuilder.Entity<Item>(entity =>
        {
            entity.HasKey(e => e.IdItem).HasName("items_pk");

            entity.ToTable("items");

            entity.Property(e => e.IdItem)
                .UseIdentityAlwaysColumn()
                .HasColumnName("id_item");
            entity.Property(e => e.Item1)
                .HasColumnType("character varying")
                .HasColumnName("item");
        });

        modelBuilder.Entity<Teacher>(entity =>
        {
            entity.HasKey(e => e.IdTeacher).HasName("teachers_pk");

            entity.ToTable("teachers");

            entity.Property(e => e.IdTeacher)
                .UseIdentityAlwaysColumn()
                .HasColumnName("id_teacher");
            entity.Property(e => e.DateBirth)
                .HasColumnType("timestamp without time zone")
                .HasColumnName("date_birth");
            entity.Property(e => e.Email)
                .HasColumnType("character varying")
                .HasColumnName("email");
            entity.Property(e => e.Experience).HasColumnName("experience");
            entity.Property(e => e.IdGender).HasColumnName("id_gender");
            entity.Property(e => e.Name)
                .HasColumnType("character varying")
                .HasColumnName("name");
            entity.Property(e => e.Patronymic)
                .HasColumnType("character varying")
                .HasColumnName("patronymic");
            entity.Property(e => e.Phone)
                .HasColumnType("character varying")
                .HasColumnName("phone");
            entity.Property(e => e.Surname)
                .HasColumnType("character varying")
                .HasColumnName("surname");

            entity.HasOne(d => d.IdGenderNavigation).WithMany(p => p.Teachers)
                .HasForeignKey(d => d.IdGender)
                .OnDelete(DeleteBehavior.ClientSetNull)
                .HasConstraintName("teachers_fk");
        });

        OnModelCreatingPartial(modelBuilder);
    }

    partial void OnModelCreatingPartial(ModelBuilder modelBuilder);
}
