using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Data.Common;
using System.Linq;
using MsBox.Avalonia;
using ReactiveUI;
using AVSchool.Models;

namespace AVSchool.ViewModels
{
    public class AddViewModel : ViewModelBase
    {
        public static _43pAstashinContext DB = new _43pAstashinContext();

        private string _name;
        private string _surname;
        private string _patronymic;
        private string _mail;
        private string _phone;

        private DateTimeOffset _birthday = new DateTimeOffset(DateTime.Now);
        private Item _selectSubject;

        private string _exp;

        private bool _genderM = true;
        private bool _enableBTN = false;

        private ObservableCollection<Item> _collSubSelect = new ObservableCollection<Item>();

        public string TName { get => _name; set => this.RaiseAndSetIfChanged(ref _name, value); }
        public string TSurname { get => _surname; set => this.RaiseAndSetIfChanged(ref _surname, value); }
        public string TPatronymic { get => _patronymic; set => this.RaiseAndSetIfChanged(ref _patronymic, value); }
        public DateTimeOffset TBirthday { get => _birthday; set => this.RaiseAndSetIfChanged(ref _birthday, value); }
        public string TMail { get => _mail; set => this.RaiseAndSetIfChanged(ref _mail, value); }
        public string TPhone { get => _phone; set => this.RaiseAndSetIfChanged(ref _phone, value); }
        public string TExp { get => _exp; set => this.RaiseAndSetIfChanged(ref _exp, value); }
        public bool TGenderM { get => _genderM; set => this.RaiseAndSetIfChanged(ref _genderM, value); }
        public bool EnableBTN { get => _enableBTN; set => this.RaiseAndSetIfChanged(ref _enableBTN, value); }

        public ObservableCollection<Item> CollSubSelect { get => _collSubSelect; set => this.RaiseAndSetIfChanged(ref _collSubSelect, value); }
        public List<Item> CollSub => DB.Items.ToList();

        private bool CheckNotNull()
        {
            if (TName == null && TSurname == null && TPatronymic == null)
            {
                var box = MessageBoxManager.GetMessageBoxStandard("", "   ");
                box.ShowAsync();
                return false;
            }

            if (TMail == null)
            {
                var box = MessageBoxManager.GetMessageBoxStandard("", "   ");
                box.ShowAsync();
                return false;
            }
            if (CollSubSelect.Count <= 0)
            {
                var box = MessageBoxManager.GetMessageBoxStandard("", "    ");
                box.ShowAsync();
                return false;

            }
            return true;
        }

        public Item SelectSubject
        {
            get => _selectSubject;
            set
            {
                int f = 0;
                foreach (var item in CollSubSelect)
                {
                    if (item == value)
                    {
                        f = 1;
                    }
                }
                if (f == 0)
                {
                    CollSubSelect.Add(value);
                }
            }
        }

        public bool AddNew()
        {
            if (CheckNotNull())
            {
                int IdGen = 1;
                int exp;
                string birtdate = TBirthday.Year + "-" + TBirthday.Month + "-" + TBirthday.Day;

                if (TGenderM == false)
                {
                    IdGen = 2;
                }

                if (TExp == null)
                {
                    exp = 0;
                }

                else
                {
                    exp = Convert.ToInt32(TExp);
                }

                Teacher nT = new Teacher()
                {
                    Name = TName,
                    Surname = TSurname,
                    Patronymic = TPatronymic,
                    DateBirth = Convert.ToDateTime(birtdate),
                    Email = TMail,
                    Phone = TPhone,
                    Experience = exp,
                    IdGender = IdGen
                };

                DB.Teachers.Add(nT);
                DB.SaveChanges();

                foreach (var item in CollSubSelect)
                {
                    DisciplinesTaught ts = new DisciplinesTaught()
                    {
                        IdTeacher = nT.IdTeacher,
                        IdItem = item.IdItem
                    };
                    DB.DisciplinesTaughts.Add(ts);
                }
                DB.SaveChanges();
                CollSubSelect.Clear();
                return true;
            }
            else
            {
                return false;
            }
        }
    }
}